# ////////////////////////////////////////////////////////////////////////////////
# // emconsole.conf //////////////////////////////////////////////////////////////
# ////////////////////////////////////////////////////////////////////////////////

# //
# // Event Monitor Project
# // version 0.6
# //
# // Juan Manuel Casillas
# // assman@gsyc.inf.uc3m.es
# //
# //
# // Event Monitor Project
# //
# // emconsole.conf
# //
# //
# // default options
# // you should modify this file to tailor the system
# //
# // This program part of Event Monitor Project (EM), 
# // a system to manage and operate a heterogeneous 
# // network, based on message-passing.
# // See License file for details
# //
# // 
# //


# directories ////////////////////////////////////////////////////////////////

set EM_HOME "$APP_HOME"

set PASS_FILE "$APP_HOME/etc/passwd"
set PIXMAP_DIR "$APP_HOME/lib/icons"

# Message file////////////////////////////////////////////////////////////////

set MESSAGE_FILE "$APP_HOME/var/alarms.in"

# fonts //////////////////////////////////////////////////////////////////////

set FONT_MENU     lucidasans-bold-12
set FONT_SUBMENU  lucidasans-12
set FONT_SSUBMENU lucidasans-italic-12
set FONT_HEADER   lucidasans-bold-10
set FONT_BUTTON   $FONT_MENU
set FONT_STATUS   lucidasans-12
set TIX_FONT_SIZE 12Point

# more fonts

# set FONT_BUTTON   "-Adobe-helvetica-bold-r-normal--*-120-*"
# set text_font     "-Adobe-Times-Medium-R-Normal-*-180-*"

# sort variables ////////////////////////////////////////////////////////////

set SORT_TYPE 0

set FILTER_BY(level)       0
set FILTER_BY(host)        0
set FILTER_BY(date)        0
set FILTER_BY(time)        0
set FILTER_BY(group)       0
set FILTER_BY(description) 0

# Message variables /////////////////////////////////////////////////////////

set MAX_MSG_WARN 15
set MAX_MSG_HEAT 30
set MAX_MSG_PANIC 50

set Menssage_Counter 0
set New_Messages 0
set Msg_First 0
set Msg_Last  0

set MsgCol_bg0 "#A0A0FF"
set MsgCol_bg1 "#7070FF"
set MsgCol_bg2 "#3030FF"
set MsgCol_bg3 "#303070"
set MsgCol_bg4 "#302050"
set MsgCol_bg5 "#70A030"
set MsgCol_bg6 "#509030"
set MsgCol_bg7 "#A02010"
set MsgCol_bg8 "#D02010"
set MsgCol_bg9 "#FF2010"

# Window Options /////////////////////////////////////////////////////////////

set X_WIN_SIZE 1135
set Y_WIN_SIZE 400

# Refresh Time ///////////////////////////////////////////////////////////////

set RFRESH_INTERVAL 10000
set WAIT_TIME 4000

# external Applications //////////////////////////////////////////////////////

set EMTLOG_APP $APP_HOME/bin/emtlog

# Application icons //////////////////////////////////////////////////////////

set ICON_EM       "@$PIXMAP_DIR/eicon.xbm"

# some funky icons ///////////////////////////////////////////////////////////

set icon_ghost    [ image create pixmap -file $PIXMAP_DIR/mini/mini-gv.xpm ]
set icon_doc      [ image create pixmap -file $PIXMAP_DIR/mini/mini-doc.xpm ]
set icon_question [ image create pixmap -file $PIXMAP_DIR/mini/mini-question.xpm ]
set icon_windows  [ image create pixmap -file $PIXMAP_DIR/mini/mini-windows.xpm ]
set icon_mah     [ image create pixmap -file $PIXMAP_DIR/mini/mini-xmahjongg.xpm ]
set icon_happy    [ image create pixmap -file $PIXMAP_DIR/mini/mini-happy.xpm ]
set icon_ray      [ image create pixmap -file $PIXMAP_DIR/mini/mini-ray.xpm ]
set icon_xeyes    [ image create pixmap -file $PIXMAP_DIR/mini/mini-eyes.xpm ]

set icon_clock    [ image create pixmap -file $PIXMAP_DIR/mini/mini-clock.xpm ]
set icon_sh       [ image create pixmap -file $PIXMAP_DIR/mini/mini-sh.xpm ]
set icon_stop     [ image create pixmap -file $PIXMAP_DIR/mini/mini-stop.xpm ]

set icon_exp      [ image create pixmap -file $PIXMAP_DIR/mini/mini-exp.xpm ]
set icon_bomb     [ image create pixmap -file $PIXMAP_DIR/mini/mini-bomb.xpm ]
set icon_exclam   [ image create pixmap -file $PIXMAP_DIR/mini/mini-exclam.xpm ]
set icon_eye      [ image create pixmap -file $PIXMAP_DIR/mini/mini.eye.xpm ]
