#!__EM_TIX_PATH__

# ////////////////////////////////////////////////////////////////////////////////
# // emconsole ///////////////////////////////////////////////////////////////////
# ////////////////////////////////////////////////////////////////////////////////

# //
# // Event Monitor Project
# // version 0.6
# //
# // Juan Manuel Casillas
# // assman@gsyc.inf.uc3m.es
# //
# //
# // Event Monitor Project
# //
# // emconsole [ Aka Event console logger ]
# //
# //
# // this program is a frontend to the Event Monitor tools
# // it lets you manage all the messages and events from
# // the console (useful for operators)
# //
# // This program part of Event Monitor Project (EM), 
# // a system to manage and operate a heterogeneous 
# // network, based on message-passing.
# // See License file for details
# //
# // Usage: emconsole
# //

# ----------------------------------------------------------------------------
# main procedure with all the things to do
# ----------------------------------------------------------------------------

proc start_up { } {
  global EM_HOME
  build_menus
  build_frame
  build_popup
  set w .main.mensajes
  Mensajes:Refresh $w
}

# ----------------------------------------------------------------------------
# load some useful packages
# ----------------------------------------------------------------------------

set APP_HOME "__EM_HOME__"
set EM_VERSION "__EM_VERSION__"

source $APP_HOME/etc/emconsole.conf
source $EM_HOME/lib/tcl/logo.tcl
source $EM_HOME/lib/tcl/login.tcl
source $EM_HOME/lib/tcl/main.tcl
source $EM_HOME/lib/tcl/mensajes.tcl
source $EM_HOME/lib/tcl/dialog.tcl
source $EM_HOME/lib/tcl/procs.tcl

wm withdraw .

# ----------------------------------------------------------------------------
# Some Useful Preferences
# ----------------------------------------------------------------------------

tix configure -fontset $TIX_FONT_SIZE

#
# some messages on start (decoration) -----------------------------------------
#

Logo:Load

set dummy 0
Logo:Message "Reading modules ..."
after 500 { set dummy 1 }
tkwait variable dummy
Logo:Message "Ready" 
after 500 { set dummy 1 }
tkwait variable dummy
 Logo:Message "Event Monitor Proyect running version $EM_VERSION" 
 after 500 { set dummy 1 }
 tkwait variable dummy
 Logo:Message "Bugs? assman@gsyc.inf.uc3m.es"
 after 500 { set dummy 1 }
 tkwait variable dummy
 after 1000 Logo:Destroy 

tkwait window .logo

#------------------------------------------------------------------------------
# launch Event Monitor Project
#------------------------------------------------------------------------------

Login:Check ok
if { [ expr {$ok == "1"} ] } {
  start_up
}

