# //////////////////////////////////////////////////////////////////////
# // main.tcl //////////////////////////////////////////////////////////
# //////////////////////////////////////////////////////////////////////

#
# //
# // Event Monitor Project
# // version 0.6
# //
# // Juan Manuel Casillas
# // assman@gsyc.inf.uc3m.es
# //
# //
# // Event Monitor Project
# //
# // main.tcl
# //
# //
# // builds GUI 
# //
# // This program part of Event Monitor Project (EM), 
# // a system to manage and operate a heterogeneous 
# // network, based on message-passing.
# // See License file for details
# //
# // 
# //
#

# //////////////////////////////////////////////////////////////////////////
# // build_popup ///////////////////////////////////////////////////////////
# //////////////////////////////////////////////////////////////////////////

proc build_popup { } {

set w .main.mensajes.top.popup
set w2 .main.mensajes.top

set hlist [.main.mensajes.top.a subwidget hlist]
tixPopupMenu $w -title "Actions"
$w bind $w2
$w bind $hlist

set menu [ $w subwidget menu ]
$menu add command -label Acknowledge \
    -command { Mensajes:Ack .main.mensajes }
$menu add command -label "Acknowledge All" \
    -command { Mensajes:AckAll .main.mensajes }

$menu add command -label Refresh -command { Mensajes:Refresh .main.mensajes }
$menu add command -label "More info" -command { Dialog:Not_Implemented }
$menu add command -label "Send Mail" -command { Dialog:Not_Implemented }

#$menu add cascade -label More -menu $menu.1
#menu $menu.1
#$menu.1 add command -label P3 -command { exit }

}

# //////////////////////////////////////////////////////////////////////////
# // build_menus ///////////////////////////////////////////////////////////
# //////////////////////////////////////////////////////////////////////////

proc build_menus { } {
    global FONT_MENU
    global FONT_SUBMENU
    global FONT_SSUBMENU
    global SORT_TYPE
    global FILTER_BY(level)      
    global FILTER_BY(host)        
    global FILTER_BY(date)        
    global FILTER_BY(time)        
    global FILTER_BY(group)       
    global FILTER_BY(description) 
    global RFRESH_INTERVAL
    global X_WIN_SIZE
    global Y_WIN_SIZE
    global ICON_EM

    if { [ expr [ winfo exists .main ] == "1" ] } {
	return 
    } 

# ----------------------------------------------------------------------------
# generate main window
# ----------------------------------------------------------------------------

set w .main
toplevel $w
wm withdraw .
wm title $w "Event Monitor \[ Main Window \]"
wm minsize $w $X_WIN_SIZE $Y_WIN_SIZE
wm iconbitmap $w $ICON_EM
wm iconname $w "Emonitor"
bind $w <Destroy> exit

set f [frame $w.menu -bd 1 -relief raised]

# ---------------------------------------------------------------------------
# file menu
# ---------------------------------------------------------------------------

menubutton $f.file -relief flat -text "File" -menu $f.file.menu \
       -font $FONT_MENU
menu $f.file.menu -tearoff no

       $f.file.menu add command -label "Open" -font $FONT_SUBMENU \
       -command { Dialog:Not_Implemented }
       $f.file.menu add command -label "Reload" -font $FONT_SUBMENU \
       -command { Dialog:Not_Implemented }
       $f.file.menu add separator
       $f.file.menu add command -label "Exit" -font $FONT_SUBMENU \
       -command { Dialog:Exit }
       

# ---------------------------------------------------------------------------
# sort menu
# ---------------------------------------------------------------------------

menubutton $f.sort -relief flat -text "Sort" -menu $f.sort.menu \
        -font $FONT_MENU
menu $f.sort.menu -tearoff no

        $f.sort.menu add command -label "Set filter" -font $FONT_SUBMENU \
	-command { Dialog:Not_Implemented }
	$f.sort.menu add separator
        $f.sort.menu add cascade -label "Filter by" -m $f.sort.menu.filter \
	-font $FONT_SSUBMENU
        $f.sort.menu add cascade -label "Sort type" -m $f.sort.menu.sort \
	-font $FONT_SSUBMENU

# filter menu ---------------------------------------------------------------

menu $f.sort.menu.filter -tearoff no

        $f.sort.menu.filter add checkbutton -label "Level" \
	-var FILTER_BY(level) -onvalue 1 -offvalue 0 \
	-font $FONT_SUBMENU
        $f.sort.menu.filter add checkbutton -label "Host" \
	-var FILTER_BY(host) -onvalue 1 -offvalue 0 \
	-font $FONT_SUBMENU
        $f.sort.menu.filter add checkbutton -label "Date" \
	-var FILTER_BY(date) -onvalue 1 -offvalue 0 \
	-font $FONT_SUBMENU	
        $f.sort.menu.filter add checkbutton -label "Time" \
	-var FILTER_BY(time) -onvalue 1 -offvalue 0 \
	-font $FONT_SUBMENU	
        $f.sort.menu.filter add checkbutton -label "Group" \
	-var FILTER_BY(description) -onvalue 1 -offvalue 0 \
	-font $FONT_SUBMENU	
        $f.sort.menu.filter add checkbutton -label "Description" \
	-var FILTER_BY(description) -onvalue 1 -offvalue 0 \
	-font $FONT_SUBMENU
	


# sort menu -----------------------------------------------------------------
	
menu $f.sort.menu.sort -tearoff no

        $f.sort.menu.sort add radiobutton -label "Ascending" \
	-var SORT_TYPE -value 0 -font $FONT_SUBMENU
        $f.sort.menu.sort add radiobutton -label "Descending" \
	-var SORT_TYPE -value 1 -font $FONT_SUBMENU


# ---------------------------------------------------------------------------
# actions menu
# ---------------------------------------------------------------------------

menubutton $f.actions -relief flat -text "Actions" -font $FONT_MENU \
-menu $f.actions.menu
menu $f.actions.menu -tearoff no

       $f.actions.menu add command -label "Acknowledge" -font $FONT_SUBMENU \
       -command { Mensajes:Ack .main.mensajes }
       $f.actions.menu add command -label "Acknowledge All" \
       -font $FONT_SUBMENU \
       -command { Mensajes:AckAll .main.mensajes }

       $f.actions.menu add command -label "Refresh" -font $FONT_SUBMENU \
       -command { Mensajes:Refresh .main.mensajes }
       $f.actions.menu add command -label "Send mail" -font $FONT_SUBMENU \
       -command { Dialog:Not_Implemented }
       $f.actions.menu add command -label "More info" -font $FONT_SUBMENU \
       -command { Dialog:Not_Implemented }


# ---------------------------------------------------------------------------
# windows menu
# ---------------------------------------------------------------------------

menubutton $f.windows -relief flat -text "Windows" -menu $f.windows.menu \
       -font $FONT_MENU
menu $f.windows.menu -tearoff no

      $f.windows.menu add command -label "Domain Explorer" -font $FONT_SUBMENU \
      -command { Dialog:Not_Implemented }
      $f.windows.menu add command -label "Configuration" -font $FONT_SUBMENU \
      -command { Dialog:Not_Implemented }
      $f.windows.menu add command -label "Node Editor" -font $FONT_SUBMENU \
      -command { Dialog:Not_Implemented }

# ---------------------------------------------------------------------------
# options menu
# ---------------------------------------------------------------------------

menubutton $f.options -relief flat -text "Options" -menu $f.options.menu \
       -font $FONT_MENU
menu $f.options.menu -tearoff no

        $f.options.menu add cascade -label "Refresh rate" \
	-m $f.options.menu.rate \
	-font $FONT_SSUBMENU

# menu refresh interval ------------------------------------------------------

menu $f.options.menu.rate -tearoff no

        $f.options.menu.rate add radiobutton -label "1 Second" \
	-var RFRESH_INTERVAL -value 1000 -font $FONT_SUBMENU
        $f.options.menu.rate add radiobutton -label "2 Seconds" \
	-var RFRESH_INTERVAL -value 2000 -font $FONT_SUBMENU
        $f.options.menu.rate add radiobutton -label "3 Seconds" \
	-var RFRESH_INTERVAL -value 3000 -font $FONT_SUBMENU
        $f.options.menu.rate add radiobutton -label "4 Seconds" \
	-var RFRESH_INTERVAL -value 4000 -font $FONT_SUBMENU
        $f.options.menu.rate add radiobutton -label "5 Seconds" \
	-var RFRESH_INTERVAL -value 5000 -font $FONT_SUBMENU
        $f.options.menu.rate add radiobutton -label "10 Seconds" \
	-var RFRESH_INTERVAL -value 10000 -font $FONT_SUBMENU
        $f.options.menu.rate add radiobutton -label "15 Seconds" \
	-var RFRESH_INTERVAL -value 15000 -font $FONT_SUBMENU
        $f.options.menu.rate add radiobutton -label "20 Seconds" \
	-var RFRESH_INTERVAL -value 20000 -font $FONT_SUBMENU
        $f.options.menu.rate add radiobutton -label "30 Seconds" \
	-var RFRESH_INTERVAL -value 30000 -font $FONT_SUBMENU
        $f.options.menu.rate add radiobutton -label "40 Seconds" \
	-var RFRESH_INTERVAL -value 40000 -font $FONT_SUBMENU
        $f.options.menu.rate add radiobutton -label "50 Seconds" \
	-var RFRESH_INTERVAL -value 50000 -font $FONT_SUBMENU
        $f.options.menu.rate add radiobutton -label "1 Minute" \
	-var RFRESH_INTERVAL -value 60000 -font $FONT_SUBMENU



# ---------------------------------------------------------------------------
# help menu
# ---------------------------------------------------------------------------

menubutton $f.help -relief flat -text "Help" -menu $f.help.menu \
       -font $FONT_MENU
menu $f.help.menu -tearoff no

       $f.help.menu add command -label "Contents" -font $FONT_SUBMENU \
       -command { Dialog:Not_Implemented }
       $f.help.menu add command -label "General Info" -font $FONT_SUBMENU \
       -command { Dialog:Not_Implemented }
       $f.help.menu add command -label "License" -font $FONT_SUBMENU \
       -command { Dialog:Not_Implemented }
       $f.help.menu add separator
       $f.help.menu add command -label "About" -font $FONT_SUBMENU \
       -command { Dialog:Not_Implemented }

# ---------------------------------------------------------------------------
# Status Line
# ---------------------------------------------------------------------------

       
# -------
# pack it 
# -------

pack $f -side top -fill x -anchor n
pack $f.file $f.sort $f.actions $f.windows $f.options -side left
pack $f.help -side right



}

# //////////////////////////////////////////////////////////////////////////
# // build_frame ///////////////////////////////////////////////////////////
# //////////////////////////////////////////////////////////////////////////

proc build_frame { } {
global STATUS_LINE
global FONT_STATUS
set w .main

    if { [ expr [ winfo exists $w ] == "0" ] } {
	return 
    } 

set f [frame $w.mensajes -bd 0 -relief flat]
pack $f -expand yes -fill both -anchor n
Mensajes:Create f
Mensajes:Show f


set et .main.mensajes.top.status
label $et -relief raised -bg white -textvariable STATUS_LINE -font $FONT_STATUS
pack $et -fill x

}
