/* //////////////////////////////////////////////////////////////////////// */
/* // servercmd.c ///////////////////////////////////////////////////////// */
/* //////////////////////////////////////////////////////////////////////// */
/* 

//
// Event Monitor Project
// version 0.6
//
// Juan Manuel Casillas
// assman@gsyc.inf.uc3m.es
//
//
// 
// emsrvcmd [ Aka Event Server Command ]
//
// this servers receives commands
// and run its asociated acition on the managed station
// 
// This program is part of Event Monitor project(EM), 
// a system to manage and operate a heterogeneous 
// network, based on message-passing.
// See License file for details
//
// WARNING
// this code is under heavy modifications,
// so no documentation nor helpers are
// provided. Soon will appear an estable
// version. 
// 
// If you compile it, its functional, 
// but is under changes and tests
//
// sorry a lot.

#include <stdio.h>
#include <stdlib.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <signal.h>
#include <netdb.h>
#include <string.h>
#include <netinet/in.h>
#include <unistd.h>
#include <strings.h>

#include "libem.h"


/* //////////////////////////////////////////////////////////////////////// */
/* // save_data() ///////////////////////////////////////////////////////// */
/* //////////////////////////////////////////////////////////////////////// */

void make_action(char *FICH, char *buffer) {
FILE *f=NULL;
 char id[MAX_CAD];
 char action[MAX_CAD];
 char lbuff[MAX_BUFFER];
 char cad[MAX_CAD];

f=fopen(FICH,"r");
 if (f==NULL) { printf("Can't open %s\n",FICH); exit(-1); }

 while (!feof(f)) {
   read_cad(f,cad);
   if (sscanf(cad,"%s %s",id,action)<0) break;
   printf("[%s] [%s] ... [%s]\n",id,action,buffer);
   if (!strcmp(id,buffer)) {
     strcpy(lbuff,action);
     strcat(lbuff," &");
     printf("Launch [%s]\n",lbuff);
     system(lbuff);
     fclose(f);
     return;
   }
 }
printf("Cant find action linked to [%s]\n",buffer);
fclose(f);
}

/* //////////////////////////////////////////////////////////////////////// */
/* // main() ////////////////////////////////////////////////////////////// */
/* //////////////////////////////////////////////////////////////////////// */


void main(int argc, char *argv[]) {
  char hname[MAX_CAD];
  int socketfd;
  int new_socketfd;
  struct hostent *host;
  struct sockaddr_in cli_address;
  int cli_size;
  char buffer[MAX_BUFFER];
  int nport;
  int n;
  int childpid;
  char *FLOG;

  bzero(hname,sizeof(hname));   /* extraigo el nombre del host donde estoy */
  gethostname(hname,sizeof(hname));    

  FLOG=getenv(ENV_VAR_DIR);
  if (FLOG==NULL) FLOG=CFILE;
  else {
	if (argc==3) FLOG=argv[2];
  }

  /* // Comprobacion de parametros /////////////////////////////////////// */

  if (argc < 2) {
    printf("\nuso: %s <port> <config_file> \n\n",argv[0]);
    exit(1);
  }
	   	   
  nport=atoi(argv[1]);


  
  printf("Server Command Running on %s in port %i\n",hname,nport);
  if ((host=gethostbyname(hname))==NULL) error(1,hname);
  socketfd = new_socket(AF_INET,SOCK_STREAM,nport,host->h_addr,1);

  listen (socketfd,MAX_PET);

  while (1) {
    cli_size=sizeof(struct sockaddr_in);
    if ((new_socketfd=
	 accept(socketfd,(struct sockaddr *)&cli_address,&cli_size))==-1) 
	  printf("Conexion no aceptada\n");

    if ((childpid=fork())<0) error(2,NULL);
    else if (childpid==0){
      bzero(buffer,sizeof(buffer));
      if ((n=recvfrom(new_socketfd,&buffer,sizeof(buffer),
		      0,(struct sockaddr *)&cli_address,&cli_size))< 0) 
	error(4,NULL);
      printf("(%d bytes)%s\n",n,buffer);
      make_action(FLOG,buffer);
      exit(0);
    }
    wait(NULL);
    close(new_socketfd);	  
     
  }
  
}
	
